﻿function b64EncodeUnicode(str) {
    // first we use encodeURIComponent to get percent-encoded UTF-8,
    // then we convert the percent encodings into raw bytes which
    // can be fed into btoa.
    return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g,
        function toSolidBytes(match, p1) {
            return String.fromCharCode('0x' + p1);
        }));
}

var $arrFieldNames = Array();
$arrFieldNames.push("GivenName");
$arrFieldNames.push("FamilyName");
$arrFieldNames.push("EntityName");
$arrFieldNames.push("EntityBPNumber");
$arrFieldNames.push("BCEntity");
$arrFieldNames.push("EmailAddress");
$arrFieldNames.push("EntityType");
$arrFieldNames.push("RegistrationNumber");
$arrFieldNames.push("ServiceRequestNumber");
$arrFieldNames.push("UBOType");
$arrFieldNames.push("Gender");
$arrFieldNames.push("PlaceOfRegistration");
$arrFieldNames.push("Passport");
$arrFieldNames.push("Nationality");
$arrFieldNames.push("PhoneNumber");
$arrFieldNames.push("Postcode");
$arrFieldNames.push("Emirates");
$arrFieldNames.push("City");
var $nRowIndex = 1;
$(document).ready(function () {
    //fnAddRow();
    document.getElementById("initSessionbtn").disabled = false;
    if ($existingJSON != undefined && $existingJSON != '') {
        fnLoadJSON($existingJSON);
    }
    $('#sessionParams').get(0).reset();
});

function fnAddRow($boolValue, $fieldName, $fieldValue) {
    var $rowCount = $('#searchTable tr').length;
    if ($boolValue == undefined || $boolValue == '') {
        $boolValue = 'AND';
    }
    if ($fieldName == undefined || $fieldName == '') {
        $fieldName = '';
    }
    if ($fieldValue == undefined || $fieldValue == '') {
        $fieldValue = '';
    }

    // Boolean Operator
    
    var $boolean = "<select id='bool_" + $nRowIndex + "' class='form-control'><option selected value='" + $boolValue+"'>AND</option><option value='OR'>OR</option></select>";
    if ($rowCount == 1) {
        $boolean = "&nbsp;-&nbsp;"
    }
    // Field Selector
    var $fieldSelector = "<select id='fieldname_" + $nRowIndex + "' class='form-control'>";
    for (i = 0; i < $arrFieldNames.length; i++) {
        if ($fieldName == $arrFieldNames[i]) {
            $fieldSelector += "<option selected>" + $arrFieldNames[i] + "</option>";
        }
        else {
            $fieldSelector += "<option>" + $arrFieldNames[i] + "</option>";
        }
    }
    $fieldSelector += "</select>";
    // Search Data Text box
    var $searchTextBox = "<input id='searchData_" + $nRowIndex + "' value='" + $fieldValue + "' class='form-control' placeholder='Enter search data'/>";
    // Action Button
    var $actionButton = "<button id='button_" + $nRowIndex + "' class='btn btn-primary btn-sm' data-index='" + $nRowIndex + "' >Remove</button>";

    // Row creation
    var $row = "<tr id='row_" + $nRowIndex + "'>";
    $row += "<td>" + $boolean + "</td>";
    $row += "<td>" + $fieldSelector + "</td>"
    $row += "<td>" + $searchTextBox + "</td>"
    $row += "<td>" + $actionButton + "</td>"
    $row += "</tr>";

    $("#searchBody").append($row);
    $("#button_" + $nRowIndex).bind("click", fnHandleRemove);
    $nRowIndex += 1;
}

$("#addSearchField").click(function () {
    fnAddRow();
});

function fnHandleRemove(e) {
    e.preventDefault();
    $index = this.getAttribute("data-index");
    $('#row_' + $index).hide(250);
    $JSon = fnGenerateJSON($index);
    fnLoadJSON($JSon);
};

// This function generates the JSON for the search
function fnGenerateJSON($ignoreIndex) {
    
    $outJson = { "searchdata": [] };
    $bDone = false;
    $index = 1;
    $firstEntry = true;
    while ($bDone == false) {
        if ($('#row_' + $index).length != 0) {
            if ($('#row_' + $index).is(':visible') == true && $index != $ignoreIndex) {
                $booleanOperator = $('#bool_' + $index).val();
                if ($booleanOperator == undefined) {
                    $booleanOperator = "";
                }
                if ($firstEntry == true) {
                    $booleanOperator = "";
                    $firstEntry = false;
                }
                $fieldName = $('#fieldname_' + $index).val();
                $searchData = $('#searchData_' + $index).val();
                $outJson['searchdata'].push({ "bool": $booleanOperator, "field": $fieldName, "data": $searchData });
            }
        }
        else {
            $bDone = true;
        }
        $index += 1;
    }
    $Json = JSON.stringify($outJson);
    return $Json;
}

// this function loads the json into the UI
function fnLoadJSON($configuredJSON) {
    $("#searchBody").empty();
    $nRowIndex = 1;
    $objJSON = JSON.parse($configuredJSON);
    if ($objJSON["searchdata"] != undefined) {
        $entries = $objJSON["searchdata"];
        for (j = 0; j < $entries.length; j++) {
            $objEntry = $entries[j];
            fnAddRow($objEntry.bool, $objEntry.field, $objEntry.data);
        }
    }
}

function deleteAttachment(fileName) {
    try {
        var url = "/SessionParameters/fileDelete"
        var formData = new FormData();
        formData.append('strfileName', fileName);
            $.ajax(
                {
                    url: url,
                    processData: false,
                    contentType: false,
                    cache: false,
                    dataType: 'json',
                    type: "POST",
                    data: formData,
                    //contentType: false,
                    //processData: false,
                    success: function (data, status, xhr) {
                        if (status == "success") {
                        }
                    }
                });
            }
    catch (e) {
        console.log(e.message);
    }
}

$("#sessionParams").submit(function () {
    try {        
        document.getElementById("initSessionbtn").disabled = true;
        $Json = fnGenerateJSON();
        $Base64Json = b64EncodeUnicode($Json);
        $("#FilterJSON").val($Base64Json);
    }
    catch (e) { console.log(e.message); }

});

//document.getElementById('btnfileUpload').addEventListener('change', function (e) {
$("#btnfileUpload").change(function (e) {

    try {
        $('#waitforfilespinner').show();
        var formData = new FormData();
        var isValid = true;
        var someSession = $('#sessionAttachmentSize').val();
        for (var fileIndex = 0; fileIndex < e.target.files.length; fileIndex++) {
            //formData.append("uploads", e.target.files[fileIndex].data);
            formData.append("file", e.target.files[fileIndex]);
            var FileExtension = e.target.files[fileIndex].name.split('.')[e.target.files[fileIndex].name.split('.').length - 1].toLowerCase();
            if (e.target.files[fileIndex].size == 0 || !(
                FileExtension == "doc" || FileExtension == "docx" || FileExtension == "dot" ||
                FileExtension == "xls" || FileExtension == "xlsx" ||
                FileExtension == "ppt" || FileExtension == "pptx" ||
                FileExtension == "jpg" || FileExtension == "jpeg" || FileExtension == "tiff" ||
                FileExtension == "bmp" || FileExtension == "png" ||
                FileExtension == "msg" || FileExtension == "pdf" || FileExtension == "gxk")) {
                var options = {};
                options['closeButton'] = true;
                options['positionClass'] = "toast-top-right";
                options['type'] = "error";
                var title = "Attachment Error";
                toastr[options.type]("We only support microsoft documents extension(doc, xls, ppt, jpg, bmp, png) along with msg, pdf and gxk extension.", title, options);
                formData = new FormData();
                $('#waitforfilespinner').hide();
                //return false;
                isValid = false;
            }
            
            if (e.target.files[fileIndex].size > (someSession * 1024 * 1024)) {
                var options = {};
                options['closeButton'] = true;
                options['positionClass'] = "toast-top-right";
                options['type'] = "error";
                var title = "Attachment Error";
                toastr[options.type]("Attachment Size of file: " + e.target.files[fileIndex].name + " is greater than file size " + someSession + "MB which is set by administrator.", title, options);
                formData = new FormData();
                $('#waitforfilespinner').hide();
                //return false;
                isValid = false;
            }
            
        }
        if (isValid == true) {

            var url = "/SessionParameters/fileUpload"
            $.ajax(
                {
                    url: url,
                    processData: false,
                    contentType: false,
                    cache: false,
                    dataType: 'json',
                    type: "POST",
                    data: formData,
                    //contentType: false,
                    //processData: false,
                    success: function (data, status, xhr) {
                        $('#waitforfilespinner').hide();
                        if (status == "success") {
                            var isValid = true;
                            //if (data == "" || data == false) {
                            const obj = JSON.parse(data);
                            if (obj.error != null || obj.error != undefined || obj.error != '' && obj.files == undefined) {
                                    var options = {};
                                    options['closeButton'] = true;
                                    options['positionClass'] = "toast-top-right";
                                    options['type'] = "error";
                                    var title = "Attachment Error";
                                toastr[options.type](/*"File you have attached is greater than setted attachment size."*/obj.error, title, options);
                                    formData = new FormData();
                                    //$('#modalUploadFile1').hide();
                                    $('#waitforfilespinner').hide();
                                    //return false;
                                    isValid = false;
                                }
                                
                            //}
                            if (isValid == true) {

                                for (index = 0; index < obj.files.length; index++) {
                                    var ul = document.getElementById("lstAttachments");
                                    var li = document.createElement("li");
                                    li.className = 'list-group-item';
                                    var divElementParent = document.createElement('div');
                                    divElementParent.style.height = '40px';
                                    li.appendChild(divElementParent);
                                    var divElementFileIcon = document.createElement('div');
                                    divElementFileIcon.className = 'file-thumbnail file-thumbnail-att';
                                    //  divElementFileIcon.style.height = '40px';
                                    var divElement = document.createElement('div');
                                    divElement.className = 'file-link';
                                    divElement.style.width = '40px';
                                    divElement.style.cssFloat = 'left';
                                    divElement.title = obj.files[index].name;
                                    divElement.appendChild(divElementFileIcon);
                                    divElementParent.appendChild(divElement);
                                    var span = document.createElement('div');
                                    span.className = 'pull-right';
                                    divElementParent.appendChild(span);
                                    li.appendChild(divElementParent);
                                    // divElement.appendChild(document.createTextNode(data[index].name));
                                    var divFile = document.createElement('div');
                                    divFile.className = 'file-info';
                                    divFile.style.textAlign = 'left';
                                    divFile.style.paddingLeft = '60px';
                                    divFile.style.lineHeight = '40px';
                                    divFile.innerHTML = obj.files[index].name;
                                    divElementParent.appendChild(divFile);
                                    var button = document.createElement('button');
                                    span.appendChild(button);
                                    button.className = 'file-delete-btn delete removeFile';
                                    //style="width:48px;height:48px;margin-top:5px" title="Delete" data-type="DELETE" data-url="?dfid=@Html.Raw(fid)" type="button"
                                    button.style.width = "40px";
                                    button.style.height = "40px";
                                    button.style.marginTop = "5px";
                                    button.title = "DELETE";
                                    button.type = 'button';
                                    button.setAttribute('name', obj.files[index].file_id);
                                    button.addEventListener('click', function () {
                                        deleteAttachment(this.getAttribute('name'));
                                        this.parentElement.parentElement.parentElement.remove();

                                        var attachmentCount = $('#lstAttachments li').length;
                                        $('#attachmentCountSpan1').text(" (" + attachmentCount + ")");

                                    }, false);
                                    // button.data.url = '\deleteAttachment?dfid =' + data[index].strFileID;
                                    var spanRemove = document.createElement('span');
                                    spanRemove.className = 'icon icon-remove icon-4x';
                                    button.appendChild(spanRemove);
                                    ul.appendChild(li);
                                }
                                var attachmentCount = $('#lstAttachments li').length;
                                $('#attachmentCountSpan1').text(" (" + attachmentCount + ")");
                            }
                        }
                        else {
                            $('#waitforfilespinner').hide();
                            // Do something on page
                        }
                    },
                });
        }
    }
    catch (e) {
        $('#waitforfilespinner').hide();
        console.log("Error Adding POI:\n" + e);
    }
});

